/* Generated by GOB (v1.0.9)   (do not edit directly) */



/* Grapevine: GNOME Notifications
 *   Notice client object
 * Author: George Lebl
 * (c) 2000 Eazel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

#ifndef __GRAPEVINE_NOTICE_H__
#define __GRAPEVINE_NOTICE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <bonobo.h>
#include <gnome-grapevine.h>

/* avoid circular headers */
#ifndef __TYPEDEF_GRAPEVINE_NOTIFICATION__
#define __TYPEDEF_GRAPEVINE_NOTIFICATION__
typedef struct _GrapevineNotification GrapevineNotification;
#endif
#ifndef __TYPEDEF_GRAPEVINE_NOTICE_LISTENER_IMPL__
#define __TYPEDEF_GRAPEVINE_NOTICE_LISTENER_IMPL__
typedef struct _GrapevineNoticeListenerImpl GrapevineNoticeListenerImpl;
#endif

#ifndef __TYPEDEF_GRAPEVINE_NOTICE_PRIORITY__
#define __TYPEDEF_GRAPEVINE_NOTICE_PRIORITY__
/* Note: this needs to be exactly the same as in gnome-grapevine.idl */
typedef enum {
	GRAPEVINE_CRITICAL,
	GRAPEVINE_MEDIUM,
	GRAPEVINE_MEDIUM_RARE,
	GRAPEVINE_INFORMATIONAL,
	GRAPEVINE_LAST /* for counting purposes */
} GrapevineNoticePriority;
#endif

#ifndef __TYPEDEF_GRAPEVINE_NOTICE_STATE__
#define __TYPEDEF_GRAPEVINE_NOTICE_STATE__
/* Note: this needs to be exactly the same as in gnome-grapevine.idl */
typedef enum {
	GRAPEVINE_NOTICE_PENDING,
	GRAPEVINE_NOTICE_POSTED,
	GRAPEVINE_NOTICE_DEAD
} GrapevineNoticeState;
#endif



/*
 * Type checking and casting macros
 */
#define GRAPEVINE_TYPE_NOTICE	(grapevine_notice_get_type())
#define GRAPEVINE_NOTICE(obj)	GTK_CHECK_CAST((obj), grapevine_notice_get_type(), GrapevineNotice)
#define GRAPEVINE_NOTICE_CONST(obj)	GTK_CHECK_CAST((obj), grapevine_notice_get_type(), GrapevineNotice const)
#define GRAPEVINE_NOTICE_CLASS(klass)	GTK_CHECK_CLASS_CAST((klass), grapevine_notice_get_type(), GrapevineNoticeClass)
#define GRAPEVINE_IS_NOTICE(obj)	GTK_CHECK_TYPE((obj), grapevine_notice_get_type ())

#ifdef GTK_CHECK_GET_CLASS
#define GRAPEVINE_NOTICE_GET_CLASS(obj)	GTK_CHECK_GET_CLASS((obj), grapevine_notice_get_type(), GrapevineNoticeClass)
#else /* !GTK_CHECK_GET_CLASS */
#define GRAPEVINE_NOTICE_GET_CLASS(obj)	((GrapevineNoticeClass *)GTK_OBJECT(obj)->klass)
#endif /* GTK_CHECK_GET_CLASS */

/* Private structure type */
typedef struct _GrapevineNoticePrivate GrapevineNoticePrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GRAPEVINE_NOTICE__
#define __TYPEDEF_GRAPEVINE_NOTICE__
typedef struct _GrapevineNotice GrapevineNotice;
#endif
struct _GrapevineNotice {
	GtkObject __parent__;
	/*< public >*/
	GNOME_Grapevine_Notice notice;
	GrapevineNotification * client;
	/*< private >*/
	GrapevineNoticePrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GrapevineNoticeClass GrapevineNoticeClass;
struct _GrapevineNoticeClass {
	GtkObjectClass __parent__;
	/*signal*/void (* posted) (GrapevineNotice * self);
	/*signal*/void (* changed) (GrapevineNotice * self);
	/*signal*/void (* removed) (GrapevineNotice * self);
};


/*
 * Public methods
 */
GtkType	grapevine_notice_get_type	(void) G_GNUC_CONST;
GrapevineNotice * 	grapevine_notice_new	(GrapevineNotification * client,
					GNOME_Grapevine_Notice notice);
void 	grapevine_notice_construct	(GrapevineNotice * self,
					GrapevineNotification * client,
					GNOME_Grapevine_Notice notice);
void 	grapevine_notice_posted	(GrapevineNotice * self);
void 	grapevine_notice_changed	(GrapevineNotice * self);
void 	grapevine_notice_removed	(GrapevineNotice * self);
void 	grapevine_notice_remove	(GrapevineNotice * self);
void 	grapevine_notice_post	(GrapevineNotice * self);
void 	grapevine_notice_add_listener	(GrapevineNotice * self,
					GrapevineNoticeListenerImpl * listener);
void 	grapevine_notice_remove_listener	(GrapevineNotice * self,
					GrapevineNoticeListenerImpl * listener);
GrapevineNoticeState 	grapevine_notice_get_state	(GrapevineNotice * self);
void 	grapevine_notice_set_priority	(GrapevineNotice * self,
					GrapevineNoticePriority priority);
GrapevineNoticePriority 	grapevine_notice_get_priority	(GrapevineNotice * self);
void 	grapevine_notice_set_keywords	(GrapevineNotice * self,
					char ** keywords);
char ** 	grapevine_notice_get_keywords	(GrapevineNotice * self);
void 	grapevine_notice_set_summary	(GrapevineNotice * self,
					const char * summary);
char * 	grapevine_notice_get_summary	(GrapevineNotice * self);
void 	grapevine_notice_set_content	(GrapevineNotice * self,
					const char * content);
char * 	grapevine_notice_get_content	(GrapevineNotice * self);
char * 	grapevine_notice_get_source	(GrapevineNotice * self);
char * 	grapevine_notice_get_uniqueID	(GrapevineNotice * self);
void 	grapevine_notice_set_expire_at	(GrapevineNotice * self,
					gulong value);
gulong 	grapevine_notice_get_expire_at	(GrapevineNotice * self);
void 	grapevine_notice_set_expire_in	(GrapevineNotice * self,
					long value);
long 	grapevine_notice_get_expire_in	(GrapevineNotice * self);
GList * 	grapevine_notice_get_related	(GrapevineNotice * self);
void 	grapevine_notice_add_relation	(GrapevineNotice * self,
					GrapevineNotice * notice);
void 	grapevine_notice_remove_relation	(GrapevineNotice * self,
					GrapevineNotice * notice);
void 	grapevine_notice_set_progress	(GrapevineNotice * self,
					int progress);
int 	grapevine_notice_get_progress	(GrapevineNotice * self);
void 	grapevine_notice_add_data	(GrapevineNotice * self,
					const char * file,
					const char * data,
					int length);
void 	grapevine_notice_add_data_from_file	(GrapevineNotice * self,
					const char * file,
					const char * local_file);
void 	grapevine_notice_remove_data	(GrapevineNotice * self,
					const char * file);
char * 	grapevine_notice_get_data	(GrapevineNotice * self,
					const char * file,
					int * size);
void 	grapevine_notice_set_post_sound	(GrapevineNotice * self,
					const char * post_sound);
char * 	grapevine_notice_get_post_sound	(GrapevineNotice * self);
void 	grapevine_notice_set_view_sound	(GrapevineNotice * self,
					const char * view_sound);
char * 	grapevine_notice_get_view_sound	(GrapevineNotice * self);
void 	grapevine_notice_set_post_sound_from_file	(GrapevineNotice * self,
					const char * filename);
void 	grapevine_notice_set_view_sound_from_file	(GrapevineNotice * self,
					const char * filename);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GRAPEVINE_NOTICE_SIGNAL_POSTED(func)	"posted",GTK_SIGNAL_FUNC(({void (* ___posted) (GrapevineNotice * self, gpointer data ) = func; ___posted; }))
#define GRAPEVINE_NOTICE_SIGNAL_CHANGED(func)	"changed",GTK_SIGNAL_FUNC(({void (* ___changed) (GrapevineNotice * self, gpointer data ) = func; ___changed; }))
#define GRAPEVINE_NOTICE_SIGNAL_REMOVED(func)	"removed",GTK_SIGNAL_FUNC(({void (* ___removed) (GrapevineNotice * self, gpointer data ) = func; ___removed; }))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GRAPEVINE_NOTICE_SIGNAL_POSTED(func)	"posted",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_SIGNAL_CHANGED(func)	"changed",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_SIGNAL_REMOVED(func)	"removed",GTK_SIGNAL_FUNC(func)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GRAPEVINE_NOTICE_GET_ARG_STATE(arg)	"state",({GrapevineNoticeState *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_PRIORITY(arg)    	"priority",({GrapevineNoticePriority z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_PRIORITY(arg)	"priority",({GrapevineNoticePriority *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_KEYWORDS(arg)    	"keywords",({char ** z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_KEYWORDS(arg)	"keywords",({char ** *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_SUMMARY(arg)    	"summary",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_SUMMARY(arg)	"summary",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_CONTENT(arg)    	"content",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_CONTENT(arg)	"content",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_SOURCE(arg)	"source",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_UNIQUEID(arg)	"uniqueID",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_EXPIRE_AT(arg)    	"expire_at",({gulong z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_EXPIRE_AT(arg)	"expire_at",({gulong *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_EXPIRE_IN(arg)    	"expire_in",({glong z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_EXPIRE_IN(arg)	"expire_in",({glong *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_PROGRESS(arg)    	"progress",({gint z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_PROGRESS(arg)	"progress",({gint *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_POST_SOUND(arg)    	"post_sound",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_POST_SOUND(arg)	"post_sound",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_ARG_VIEW_SOUND(arg)    	"view_sound",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_GET_ARG_VIEW_SOUND(arg)	"view_sound",({char * *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GRAPEVINE_NOTICE_GET_ARG_STATE(arg)	"state",(GrapevineNoticeState *)(arg)
#define GRAPEVINE_NOTICE_ARG_PRIORITY(arg)    	"priority",(GrapevineNoticePriority )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_PRIORITY(arg)	"priority",(GrapevineNoticePriority *)(arg)
#define GRAPEVINE_NOTICE_ARG_KEYWORDS(arg)    	"keywords",(char ** )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_KEYWORDS(arg)	"keywords",(char ** *)(arg)
#define GRAPEVINE_NOTICE_ARG_SUMMARY(arg)    	"summary",(char * )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_SUMMARY(arg)	"summary",(char * *)(arg)
#define GRAPEVINE_NOTICE_ARG_CONTENT(arg)    	"content",(char * )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_CONTENT(arg)	"content",(char * *)(arg)
#define GRAPEVINE_NOTICE_GET_ARG_SOURCE(arg)	"source",(char * *)(arg)
#define GRAPEVINE_NOTICE_GET_ARG_UNIQUEID(arg)	"uniqueID",(char * *)(arg)
#define GRAPEVINE_NOTICE_ARG_EXPIRE_AT(arg)    	"expire_at",(gulong )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_EXPIRE_AT(arg)	"expire_at",(gulong *)(arg)
#define GRAPEVINE_NOTICE_ARG_EXPIRE_IN(arg)    	"expire_in",(glong )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_EXPIRE_IN(arg)	"expire_in",(glong *)(arg)
#define GRAPEVINE_NOTICE_ARG_PROGRESS(arg)    	"progress",(gint )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_PROGRESS(arg)	"progress",(gint *)(arg)
#define GRAPEVINE_NOTICE_ARG_POST_SOUND(arg)    	"post_sound",(char * )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_POST_SOUND(arg)	"post_sound",(char * *)(arg)
#define GRAPEVINE_NOTICE_ARG_VIEW_SOUND(arg)    	"view_sound",(char * )(arg)
#define GRAPEVINE_NOTICE_GET_ARG_VIEW_SOUND(arg)	"view_sound",(char * *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
