/* Generated by GOB (v1.0.9)   (do not edit directly) */



/* Grapevine: GNOME Notifications
 *   Notification clientobject
 * Author: George Lebl
 * (c) 2000 Eazel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

#ifndef __GRAPEVINE_NOTIFICATION_H__
#define __GRAPEVINE_NOTIFICATION_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <bonobo.h>
#include <liboaf/liboaf.h>
#include <gnome-grapevine.h>

/* avoid circular headers */
#ifndef __TYPEDEF_GRAPEVINE_NOTICE__
#define __TYPEDEF_GRAPEVINE_NOTICE__
typedef struct _GrapevineNotice GrapevineNotice;
#endif
#ifndef __TYPEDEF_GRAPEVINE_NOTICE_LISTENER_IMPL__
#define __TYPEDEF_GRAPEVINE_NOTICE_LISTENER_IMPL__
typedef struct _GrapevineNoticeListenerImpl GrapevineNoticeListenerImpl;
#endif

#ifndef __TYPEDEF_GRAPEVINE_NOTICE_PRIORITY__
#define __TYPEDEF_GRAPEVINE_NOTICE_PRIORITY__
/* Note: this needs to be exactly the same as in gnome-grapevine.idl */
typedef enum {
	GRAPEVINE_CRITICAL,
	GRAPEVINE_MEDIUM,
	GRAPEVINE_MEDIUM_RARE,
	GRAPEVINE_INFORMATIONAL
} GrapevineNoticePriority;
#endif



/*
 * Type checking and casting macros
 */
#define GRAPEVINE_TYPE_NOTIFICATION	(grapevine_notification_get_type())
#define GRAPEVINE_NOTIFICATION(obj)	GTK_CHECK_CAST((obj), grapevine_notification_get_type(), GrapevineNotification)
#define GRAPEVINE_NOTIFICATION_CONST(obj)	GTK_CHECK_CAST((obj), grapevine_notification_get_type(), GrapevineNotification const)
#define GRAPEVINE_NOTIFICATION_CLASS(klass)	GTK_CHECK_CLASS_CAST((klass), grapevine_notification_get_type(), GrapevineNotificationClass)
#define GRAPEVINE_IS_NOTIFICATION(obj)	GTK_CHECK_TYPE((obj), grapevine_notification_get_type ())

#ifdef GTK_CHECK_GET_CLASS
#define GRAPEVINE_NOTIFICATION_GET_CLASS(obj)	GTK_CHECK_GET_CLASS((obj), grapevine_notification_get_type(), GrapevineNotificationClass)
#else /* !GTK_CHECK_GET_CLASS */
#define GRAPEVINE_NOTIFICATION_GET_CLASS(obj)	((GrapevineNotificationClass *)GTK_OBJECT(obj)->klass)
#endif /* GTK_CHECK_GET_CLASS */

/* Private structure type */
typedef struct _GrapevineNotificationPrivate GrapevineNotificationPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GRAPEVINE_NOTIFICATION__
#define __TYPEDEF_GRAPEVINE_NOTIFICATION__
typedef struct _GrapevineNotification GrapevineNotification;
#endif
struct _GrapevineNotification {
	GtkObject __parent__;
	/*< public >*/
	BonoboObject * listener;
	char * default_source;
	/*< private >*/
	GrapevineNotificationPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GrapevineNotificationClass GrapevineNotificationClass;
struct _GrapevineNotificationClass {
	GtkObjectClass __parent__;
	GrapevineNotice * (* make_notice_client) (GrapevineNotification * self, GNOME_Grapevine_Notice corba_object);
};


/*
 * Public methods
 */
GtkType	grapevine_notification_get_type	(void) G_GNUC_CONST;
GrapevineNotification * 	grapevine_notification_new	(void);
void 	grapevine_notification_set_default_source	(GrapevineNotification * self,
					char * default_source);
GrapevineNotice * 	grapevine_notification_notice_from_corba	(GrapevineNotification * self,
					GNOME_Grapevine_Notice corba_object,
					gboolean create_if_none);
GrapevineNotice * 	grapevine_notification_create_notice	(GrapevineNotification * self,
					const char * source);
GrapevineNotice * 	grapevine_notification_find_notice	(GrapevineNotification * self,
					const char * uniqueID);
GList * 	grapevine_notification_get_current_notices	(GrapevineNotification * self);
void 	grapevine_notification_set_listener	(GrapevineNotification * self,
					GrapevineNoticeListenerImpl * listener);
void 	grapevine_notification_run_browse_dialog	(GrapevineNotification * self);
void 	grapevine_notification_run_properties_dialog	(GrapevineNotification * self);
GList * 	grapevine_notification_get_languages	(GrapevineNotification * self);
void 	grapevine_notification_post_simple_notice	(GrapevineNotification * self,
					const char * source,
					GrapevineNoticePriority priority,
					char * keywords[],
					const char * summary,
					const char * content,
					long expire_in,
					char ** uniqueID);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GRAPEVINE_NOTIFICATION_ARG_DEFAULT_SOURCE(arg)    	"default_source",({char * z = (arg); z;})
#define GRAPEVINE_NOTIFICATION_GET_ARG_DEFAULT_SOURCE(arg)	"default_source",({char * *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GRAPEVINE_NOTIFICATION_ARG_DEFAULT_SOURCE(arg)    	"default_source",(char * )(arg)
#define GRAPEVINE_NOTIFICATION_GET_ARG_DEFAULT_SOURCE(arg)	"default_source",(char * *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
