/* Generated by GOB (v1.0.9)   (do not edit directly) */



/* Grapevine: GNOME Notifications
 *   The real notice object
 * Author: George Lebl
 * (c) 2000 Eazel, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

#ifndef __GRAPEVINE_NOTICE_REAL_H__
#define __GRAPEVINE_NOTICE_REAL_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <bonobo.h>
#include <gnome-xml/tree.h>
#include <gnome-xml/xmlmemory.h>
#include "gnome-grapevine.h"

#ifndef __TYPEDEF_GRAPEVINE_NOTICE_PRIORITY__
#define __TYPEDEF_GRAPEVINE_NOTICE_PRIORITY__
/* Note: this needs to be exactly the same as in gnome-grapevine.idl */
typedef enum {
	GRAPEVINE_CRITICAL,
	GRAPEVINE_MEDIUM,
	GRAPEVINE_MEDIUM_RARE,
	GRAPEVINE_INFORMATIONAL,
	GRAPEVINE_LAST /* for counting purposes, also used for "invalid" */
} GrapevineNoticePriority;
#endif

#define GRAPEVINE_CRITICAL_STRING "Critical"
#define GRAPEVINE_MEDIUM_STRING "Medium"
#define GRAPEVINE_MEDIUM_RARE_STRING "MediumRare"
#define GRAPEVINE_INFORMATIONAL_STRING "Informational"

#ifndef __TYPEDEF_GRAPEVINE_NOTICE_STATE__
#define __TYPEDEF_GRAPEVINE_NOTICE_STATE__
/* Note: this needs to be exactly the same as in gnome-grapevine.idl */
typedef enum {
	GRAPEVINE_NOTICE_PENDING,
	GRAPEVINE_NOTICE_POSTED,
	GRAPEVINE_NOTICE_DEAD
} GrapevineNoticeState;
#endif

#ifndef __TYPEDEF_GRAPEVINE_NOTICE_IMPL__
#define __TYPEDEF_GRAPEVINE_NOTICE_IMPL__
typedef struct _GrapevineNoticeImpl GrapevineNoticeImpl;
#endif

#ifndef __TYPEDEF_GRAPEVINE_MAIN__
#define __TYPEDEF_GRAPEVINE_MAIN__
typedef struct _GrapevineMain GrapevineMain;
#endif

/*
 * Utility functions useful elsewhere
 */
const char * grapevine_notice_priority_to_string (GrapevineNoticePriority priority);
/* This returtns _LAST as invalid */
GrapevineNoticePriority grapevine_notice_string_to_priority (const char *string);



/*
 * Type checking and casting macros
 */
#define GRAPEVINE_TYPE_NOTICE_REAL	(grapevine_notice_real_get_type())
#define GRAPEVINE_NOTICE_REAL(obj)	GTK_CHECK_CAST((obj), grapevine_notice_real_get_type(), GrapevineNoticeReal)
#define GRAPEVINE_NOTICE_REAL_CONST(obj)	GTK_CHECK_CAST((obj), grapevine_notice_real_get_type(), GrapevineNoticeReal const)
#define GRAPEVINE_NOTICE_REAL_CLASS(klass)	GTK_CHECK_CLASS_CAST((klass), grapevine_notice_real_get_type(), GrapevineNoticeRealClass)
#define GRAPEVINE_IS_NOTICE_REAL(obj)	GTK_CHECK_TYPE((obj), grapevine_notice_real_get_type ())

#ifdef GTK_CHECK_GET_CLASS
#define GRAPEVINE_NOTICE_REAL_GET_CLASS(obj)	GTK_CHECK_GET_CLASS((obj), grapevine_notice_real_get_type(), GrapevineNoticeRealClass)
#else /* !GTK_CHECK_GET_CLASS */
#define GRAPEVINE_NOTICE_REAL_GET_CLASS(obj)	((GrapevineNoticeRealClass *)GTK_OBJECT(obj)->klass)
#endif /* GTK_CHECK_GET_CLASS */

/* Private structure type */
typedef struct _GrapevineNoticeRealPrivate GrapevineNoticeRealPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GRAPEVINE_NOTICE_REAL__
#define __TYPEDEF_GRAPEVINE_NOTICE_REAL__
typedef struct _GrapevineNoticeReal GrapevineNoticeReal;
#endif
struct _GrapevineNoticeReal {
	GtkObject __parent__;
	/*< public >*/
	gulong timestamp;
	GList * impl_objects;
	GrapevineNoticeState state;
	char * source;
	char * uniqueID;
	GrapevineNoticePriority priority;
	char ** keywords;
	char * summary;
	char * content;
	unsigned long expire_at;
	GList * related;
	int progress;
	char * post_sound;
	char * view_sound;
	/*< private >*/
	GrapevineNoticeRealPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GrapevineNoticeRealClass GrapevineNoticeRealClass;
struct _GrapevineNoticeRealClass {
	GtkObjectClass __parent__;
	/*signal*/void (* remove) (GrapevineNoticeReal * self);
	/*signal*/void (* post) (GrapevineNoticeReal * self);
	/*signal*/void (* change) (GrapevineNoticeReal * self);
	/*signal*/void (* posted) (GrapevineNoticeReal * self);
	/*signal*/void (* changed) (GrapevineNoticeReal * self);
	/*signal*/void (* removed) (GrapevineNoticeReal * self);
	/*signal*/void (* set_priority) (GrapevineNoticeReal * self, GrapevineNoticePriority priority);
	/*signal*/void (* set_keywords) (GrapevineNoticeReal * self, char ** keywords);
	/*signal*/void (* set_summary) (GrapevineNoticeReal * self, const char * summary);
	/*signal*/void (* set_content) (GrapevineNoticeReal * self, const char * content);
	/*signal*/void (* set_expire_at) (GrapevineNoticeReal * self, unsigned long expire_at);
	/*signal*/void (* add_relation) (GrapevineNoticeReal * self, GrapevineNoticeReal * notice);
	/*signal*/void (* remove_relation) (GrapevineNoticeReal * self, GrapevineNoticeReal * notice);
	/*signal*/void (* set_progress) (GrapevineNoticeReal * self, int progress);
	/*signal*/void (* add_data) (GrapevineNoticeReal * self, const char * file, const char * data, int length);
	/*signal*/void (* remove_data) (GrapevineNoticeReal * self, const char * file);
	/*signal*/const char * (* peek_data) (GrapevineNoticeReal * self, const char * file, int * size);
	/*signal*/void (* set_post_sound) (GrapevineNoticeReal * self, const char * post_sound);
	/*signal*/void (* set_view_sound) (GrapevineNoticeReal * self, const char * view_sound);
};


/*
 * Public methods
 */
GtkType	grapevine_notice_real_get_type	(void) G_GNUC_CONST;
GrapevineNoticeReal * 	grapevine_notice_real_new	(const char * source);
GrapevineNoticeReal * 	grapevine_notice_real_new_with_id	(const char * uniqueID);
void 	grapevine_notice_real_construct	(GrapevineNoticeReal * self,
					char * source);
void 	grapevine_notice_real_remove	(GrapevineNoticeReal * self);
void 	grapevine_notice_real_do_timestamp	(GrapevineNoticeReal * self);
void 	grapevine_notice_real_post	(GrapevineNoticeReal * self);
void 	grapevine_notice_real_change	(GrapevineNoticeReal * self);
BonoboObject * 	grapevine_notice_real_get_impl	(GrapevineNoticeReal * self,
					gulong client_cookie);
void 	grapevine_notice_real_posted	(GrapevineNoticeReal * self);
void 	grapevine_notice_real_changed	(GrapevineNoticeReal * self);
void 	grapevine_notice_real_removed	(GrapevineNoticeReal * self);
void 	grapevine_notice_real_set_priority	(GrapevineNoticeReal * self,
					GrapevineNoticePriority priority);
void 	grapevine_notice_real_set_keywords	(GrapevineNoticeReal * self,
					char ** keywords);
gboolean 	grapevine_notice_real_has_keyword	(GrapevineNoticeReal * self,
					const char * keyword);
void 	grapevine_notice_real_set_summary	(GrapevineNoticeReal * self,
					const char * summary);
void 	grapevine_notice_real_set_content	(GrapevineNoticeReal * self,
					const char * content);
void 	grapevine_notice_real_set_expire_at	(GrapevineNoticeReal * self,
					unsigned long expire_at);
void 	grapevine_notice_real_add_relation	(GrapevineNoticeReal * self,
					GrapevineNoticeReal * notice);
void 	grapevine_notice_real_remove_relation	(GrapevineNoticeReal * self,
					GrapevineNoticeReal * notice);
void 	grapevine_notice_real_set_progress	(GrapevineNoticeReal * self,
					int progress);
void 	grapevine_notice_real_add_data	(GrapevineNoticeReal * self,
					const char * file,
					const char * data,
					int length);
void 	grapevine_notice_real_remove_data	(GrapevineNoticeReal * self,
					const char * file);
const char * 	grapevine_notice_real_peek_data	(GrapevineNoticeReal * self,
					const char * file,
					int * size);
void 	grapevine_notice_real_set_post_sound	(GrapevineNoticeReal * self,
					const char * post_sound);
void 	grapevine_notice_real_set_view_sound	(GrapevineNoticeReal * self,
					const char * view_sound);
void 	grapevine_notice_real_play_post_sound	(GrapevineNoticeReal * self);
void 	grapevine_notice_real_play_view_sound	(GrapevineNoticeReal * self);
xmlNode * 	grapevine_notice_real_make_xml	(GrapevineNoticeReal * self,
					xmlNode * parent,
					const char * data_dir,
					int * data_num);
void 	grapevine_notice_real_setup_from_xml	(GrapevineNoticeReal * self,
					GrapevineMain * main_object,
					xmlNode * node,
					const char * data_dir);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GRAPEVINE_NOTICE_REAL_SIGNAL__REMOVE(func)	"remove",GTK_SIGNAL_FUNC(({void (* ___remove) (GrapevineNoticeReal * self, gpointer data ) = func; ___remove; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_POST(func)	"post",GTK_SIGNAL_FUNC(({void (* ___post) (GrapevineNoticeReal * self, gpointer data ) = func; ___post; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_CHANGE(func)	"change",GTK_SIGNAL_FUNC(({void (* ___change) (GrapevineNoticeReal * self, gpointer data ) = func; ___change; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_POSTED(func)	"posted",GTK_SIGNAL_FUNC(({void (* ___posted) (GrapevineNoticeReal * self, gpointer data ) = func; ___posted; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_CHANGED(func)	"changed",GTK_SIGNAL_FUNC(({void (* ___changed) (GrapevineNoticeReal * self, gpointer data ) = func; ___changed; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_REMOVED(func)	"removed",GTK_SIGNAL_FUNC(({void (* ___removed) (GrapevineNoticeReal * self, gpointer data ) = func; ___removed; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_PRIORITY(func)	"set_priority",GTK_SIGNAL_FUNC(({void (* ___set_priority) (GrapevineNoticeReal * self, GrapevineNoticePriority priority, gpointer data ) = func; ___set_priority; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_KEYWORDS(func)	"set_keywords",GTK_SIGNAL_FUNC(({void (* ___set_keywords) (GrapevineNoticeReal * self, char ** keywords, gpointer data ) = func; ___set_keywords; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_SUMMARY(func)	"set_summary",GTK_SIGNAL_FUNC(({void (* ___set_summary) (GrapevineNoticeReal * self, const char * summary, gpointer data ) = func; ___set_summary; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_CONTENT(func)	"set_content",GTK_SIGNAL_FUNC(({void (* ___set_content) (GrapevineNoticeReal * self, const char * content, gpointer data ) = func; ___set_content; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_EXPIRE_AT(func)	"set_expire_at",GTK_SIGNAL_FUNC(({void (* ___set_expire_at) (GrapevineNoticeReal * self, unsigned long expire_at, gpointer data ) = func; ___set_expire_at; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_ADD_RELATION(func)	"add_relation",GTK_SIGNAL_FUNC(({void (* ___add_relation) (GrapevineNoticeReal * self, GrapevineNoticeReal * notice, gpointer data ) = func; ___add_relation; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_REMOVE_RELATION(func)	"remove_relation",GTK_SIGNAL_FUNC(({void (* ___remove_relation) (GrapevineNoticeReal * self, GrapevineNoticeReal * notice, gpointer data ) = func; ___remove_relation; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_PROGRESS(func)	"set_progress",GTK_SIGNAL_FUNC(({void (* ___set_progress) (GrapevineNoticeReal * self, int progress, gpointer data ) = func; ___set_progress; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_ADD_DATA(func)	"add_data",GTK_SIGNAL_FUNC(({void (* ___add_data) (GrapevineNoticeReal * self, const char * file, const char * data, int length, gpointer data ) = func; ___add_data; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_REMOVE_DATA(func)	"remove_data",GTK_SIGNAL_FUNC(({void (* ___remove_data) (GrapevineNoticeReal * self, const char * file, gpointer data ) = func; ___remove_data; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_PEEK_DATA(func)	"peek_data",GTK_SIGNAL_FUNC(({const char * (* ___peek_data) (GrapevineNoticeReal * self, const char * file, int * size, gpointer data ) = func; ___peek_data; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_POST_SOUND(func)	"set_post_sound",GTK_SIGNAL_FUNC(({void (* ___set_post_sound) (GrapevineNoticeReal * self, const char * post_sound, gpointer data ) = func; ___set_post_sound; }))
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_VIEW_SOUND(func)	"set_view_sound",GTK_SIGNAL_FUNC(({void (* ___set_view_sound) (GrapevineNoticeReal * self, const char * view_sound, gpointer data ) = func; ___set_view_sound; }))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GRAPEVINE_NOTICE_REAL_SIGNAL__REMOVE(func)	"remove",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_POST(func)	"post",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_CHANGE(func)	"change",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_POSTED(func)	"posted",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_CHANGED(func)	"changed",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_REMOVED(func)	"removed",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_PRIORITY(func)	"set_priority",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_KEYWORDS(func)	"set_keywords",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_SUMMARY(func)	"set_summary",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_CONTENT(func)	"set_content",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_EXPIRE_AT(func)	"set_expire_at",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_ADD_RELATION(func)	"add_relation",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_REMOVE_RELATION(func)	"remove_relation",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_PROGRESS(func)	"set_progress",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_ADD_DATA(func)	"add_data",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_REMOVE_DATA(func)	"remove_data",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_PEEK_DATA(func)	"peek_data",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_POST_SOUND(func)	"set_post_sound",GTK_SIGNAL_FUNC(func)
#define GRAPEVINE_NOTICE_REAL_SIGNAL_SET_VIEW_SOUND(func)	"set_view_sound",GTK_SIGNAL_FUNC(func)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GRAPEVINE_NOTICE_REAL_ARG_STATE(arg)    	"state",({GrapevineNoticeState z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_STATE(arg)	"state",({GrapevineNoticeState *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_SOURCE(arg)    	"source",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_SOURCE(arg)	"source",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_UNIQUEID(arg)	"uniqueID",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_PRIORITY(arg)    	"priority",({GrapevineNoticePriority z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_PRIORITY(arg)	"priority",({GrapevineNoticePriority *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_KEYWORDS(arg)    	"keywords",({char ** z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_KEYWORDS(arg)	"keywords",({char ** *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_SUMMARY(arg)    	"summary",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_SUMMARY(arg)	"summary",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_CONTENT(arg)    	"content",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_CONTENT(arg)	"content",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_EXPIRE_AT(arg)    	"expire_at",({gulong z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_EXPIRE_AT(arg)	"expire_at",({gulong *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_EXPIRE_IN(arg)    	"expire_in",({glong z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_EXPIRE_IN(arg)	"expire_in",({glong *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_RELATED(arg)	"related",({GList * *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_PROGRESS(arg)    	"progress",({gint z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_PROGRESS(arg)	"progress",({gint *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_POST_SOUND(arg)    	"post_sound",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_POST_SOUND(arg)	"post_sound",({char * *z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_ARG_VIEW_SOUND(arg)    	"view_sound",({char * z = (arg); z;})
#define GRAPEVINE_NOTICE_REAL_GET_ARG_VIEW_SOUND(arg)	"view_sound",({char * *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GRAPEVINE_NOTICE_REAL_ARG_STATE(arg)    	"state",(GrapevineNoticeState )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_STATE(arg)	"state",(GrapevineNoticeState *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_SOURCE(arg)    	"source",(char * )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_SOURCE(arg)	"source",(char * *)(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_UNIQUEID(arg)	"uniqueID",(char * *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_PRIORITY(arg)    	"priority",(GrapevineNoticePriority )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_PRIORITY(arg)	"priority",(GrapevineNoticePriority *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_KEYWORDS(arg)    	"keywords",(char ** )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_KEYWORDS(arg)	"keywords",(char ** *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_SUMMARY(arg)    	"summary",(char * )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_SUMMARY(arg)	"summary",(char * *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_CONTENT(arg)    	"content",(char * )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_CONTENT(arg)	"content",(char * *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_EXPIRE_AT(arg)    	"expire_at",(gulong )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_EXPIRE_AT(arg)	"expire_at",(gulong *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_EXPIRE_IN(arg)    	"expire_in",(glong )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_EXPIRE_IN(arg)	"expire_in",(glong *)(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_RELATED(arg)	"related",(GList * *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_PROGRESS(arg)    	"progress",(gint )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_PROGRESS(arg)	"progress",(gint *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_POST_SOUND(arg)    	"post_sound",(char * )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_POST_SOUND(arg)	"post_sound",(char * *)(arg)
#define GRAPEVINE_NOTICE_REAL_ARG_VIEW_SOUND(arg)    	"view_sound",(char * )(arg)
#define GRAPEVINE_NOTICE_REAL_GET_ARG_VIEW_SOUND(arg)	"view_sound",(char * *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
